<?php
/* Autor...:  */
/* Esquema.: MST_ValidezOf.xml */
/* Generado: 2021-09-07 05:02:21 */

/* Metodos de acceso a los campos de la tabla MST_ValidezOf */
abstract class BaseMST_ValidezOfBN
{
    /* Campos de la tabla */
    private $i_ValidezId;    // ValidezId: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $i_CantHoras;    // CantHoras: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )

    /* Establece el valor del campo ValidezId */
    public function setValidezId( $i_ValidezId )
    {
        $this->i_ValidezId = $i_ValidezId;
    }

    /* Obtiene el valor del campo ValidezId */
    public function getValidezId()
    {
        return $this->i_ValidezId;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo CantHoras */
    public function setCantHoras( $i_CantHoras )
    {
        $this->i_CantHoras = $i_CantHoras;
    }

    /* Obtiene el valor del campo CantHoras */
    public function getCantHoras()
    {
        return $this->i_CantHoras;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'ValidezId' => $this->getValidezId(),
            'Descripcion' => $this->getDescripcion(),
            'CantHoras' => $this->getCantHoras(),
            'Estado' => $this->getEstado(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto MST_ValidezOfBN desde un RecordSet */
    public static function retrieveByRs( $o_MST_ValidezOfRs )
    {
        $o_MST_ValidezOfBN = new MST_ValidezOfBN();
        $o_MST_ValidezOfBN->setValidezId( ( integer ) $o_MST_ValidezOfRs[ "ValidezId" ] );
        $o_MST_ValidezOfBN->setDescripcion( $o_MST_ValidezOfRs[ "Descripcion" ] );
        $o_MST_ValidezOfBN->setCantHoras( ( integer ) $o_MST_ValidezOfRs[ "CantHoras" ] );
        $o_MST_ValidezOfBN->setEstado( $o_MST_ValidezOfRs[ "Estado" ] );
        $o_MST_ValidezOfBN->setUsuarioCreacion( $o_MST_ValidezOfRs[ "UsuarioCreacion" ] );
        $o_MST_ValidezOfBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_MST_ValidezOfRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_MST_ValidezOfBN->setUsuarioModificacion( $o_MST_ValidezOfRs[ "UsuarioModificacion" ] );
        $o_MST_ValidezOfBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_MST_ValidezOfRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        return $o_MST_ValidezOfBN;
    }
}
?>